//
//  exercise1.cpp
//  Session 8
//
//  Created by Luis Angel on 5/21/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

struct Card
{
	const char *suit;	// A pointer to a constant char (C string).
	int face;			// A number between 1 and 13.
};

void printCardByRef( const Card& ref )
{
	cout << "Your card is a " << ref.face << " of " << ref.suit << endl;
}

void printCardByPtr( const Card *ptr )
{
	cout << "Your card is a " << ptr->face << " of " << (*ptr).suit << endl;
}

int main1(int argc, const char * argv[])
{
	Card c1;			// Create a card.
	c1.suit = "Hearts";	// Fill out its data members
	c1.face = 3;
	
	Card c2;			// Create another card.
	c2 = c1;			// Assignment member-to-member.
	c2.suit = "Spades";
	
	Card deck[52];		// An array of cards.
	deck[0].suit = "Diamonds";
	deck[0].face = 5;
	
	Card *cPtr;			// A pointer to a card.
	cPtr = &c1;
	(*cPtr).face = 1;	// Modify a member using '.'
	cPtr->face = 7;		// Modify a member using '->'
	
	Card& cRef = c2;	// A reference to a card.
	cRef.face = 13;
	
	printCardByRef( c1 );
	printCardByPtr( &c2 );
	
    return 0;
}
