//
//  time.cpp
//  Session 8
//
//  Created by Luis Angel on 5/21/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

struct Time
{
private:
	int hour = 0;	// 0 - 23.
	int minute = 0;	// 0 - 59.
	int second = 0;	// 0 - 59.
	
public:
	Time();
	void setTime( int, int, int );
	void print24() const;
	void printAMPM() const;
	int compare( const Time& in ) const;
};

/*
 * Defining Time's interface (public functions).
 */

// Constructor.
Time::Time()
{
	hour = minute = second = 0;
}

// Set time.
void Time::setTime( int h, int m, int s)
{
	hour = ( h >= 0 && h <= 23 )? h: 0;
	minute = ( m >= 0 && m <= 59 )? m: 0;
	second = ( s >= 0 && s <= 59 )? s: 0;
}

// Print in 24-hour format.
void Time::print24() const
{
	cout << ((hour < 10)? "0": "") << hour << ":"
		 << ((minute < 10)? "0": "") << minute << ":"
		 << ((second < 10)? "0": "") << second << endl;
}

// Print in AM or PM format.
void Time::printAMPM() const
{
	cout << ((hour == 0 || hour == 12)? 12: hour%12) << ":"
	<< ((minute < 10)? "0": "") << minute << ":"
	<< ((second < 10)? "0": "") << second << " "
	<< ((hour < 12)? "AM": "PM") << endl;
}

// Compare another object with THIS object.
int Time::compare( const Time& in ) const
{
	if( this->hour < in.hour )
		return -1;
	else
	{
		if( this->hour > in.hour )
			return 1;
		else
		{				// If reached this point, hours are the same.
			if( this->minute < in.minute )
				return -1;
			else
			{
				if( this->minute > in.minute )
					return 1;
				else
				{		// If reached this point, minutes are the same.
					if( this->second < in.second )
						return -1;
					else
					{
						if( this->second > in.second )
							return 1;
						else
							return 0;	// If reached this point, they are equal.
					}
				}
			}
		}
	}
}

/*
 * Main program function.
 */
int main()
{
	Time sunset;							// Object
	sunset.setTime( 20, 5, 30 );
	
	Time *sunsetPtr = &sunset;				// Pointer
	(*sunsetPtr).print24();
	
	Time& sunsetRef = sunset;				// Reference
	sunsetRef.printAMPM();
	
	Time mealTimes[3];						// Array
	mealTimes[0].setTime( 11, 0, 0 );		//  Breakfast
	(*(mealTimes+1)).setTime( 16, 30, 0 );	//  Lunch
	(mealTimes+2)->setTime( 22, 30, 30 );	//  Dinner
	
	const Time midnight;
	midnight.print24();
	midnight.printAMPM();
	
	cout << sunset.compare( midnight ) << endl;
	cout << sunset.compare( sunset ) << endl;
	cout << midnight.compare( sunset ) << endl;
}










